//=========================================================================

function my_getelementbyid( id ) {
	if ( document.getElementById )
		return document.getElementById( id );
	else if ( document.all )
		return document.all[ id ];
	else if ( document.layers )
		return document.layers[ id ];
	else
		alert( "Browser not compatible" ); // TODO
}

function URLDecode( s ) {
	// this is supposed to be the inverse operation of java's URLEncode
	return unescape( s ).replace( /\+/g, " " );
}
// =========================================================================

function xmlhttpnew() {
	var xmlhttp_ = false;
	/* @cc_on @ */
	/*
	 * @if (@_jscript_version >= 5) // JScript gives us Conditional compilation,
	 * we can cope with old IE versions. // and security blocked creation of the
	 * objects. try { xmlhttp_ = new ActiveXObject("Msxml2.XMLHTTP"); } catch (e) {
	 * try { xmlhttp_ = new ActiveXObject("Microsoft.XMLHTTP"); } catch (E) {
	 * xmlhttp_ = false; } } @end @
	 */
	if ( !xmlhttp_ && typeof XMLHttpRequest != 'undefined' ) {
		try {
			xmlhttp_ = new XMLHttpRequest();
		}
		catch ( e ) {
			xmlhttp_ = false;
		}
	}
	if ( !xmlhttp_ && window.createRequest ) {
		try {
			xmlhttp_ = window.createRequest();
		}
		catch ( e ) {
			xmlhttp_ = false;
		}
	}
	if ( !xmlhttp_ ) {
		try {
			xmlhttp_ = new ActiveXObject( "Msxml2.XMLHTTP" );
		}
		catch ( e ) {
			try {
				xmlhttp_ = new ActiveXObject( "Microsoft.XMLHTTP" );
			}
			catch ( E ) {}
		}
	}
	if ( !xmlhttp_ ) {
		alert( "Browser does not support javascript HTTP Request !!" );
	}
	return xmlhttp_;
}

var xmlhttp = xmlhttpnew();

function getTime() {
	return new Date().getTime();
}

var lastUpdateData;
var currentUpdateData;

/*
 * this function applies a single line of the received update page
 */
function applyLine( line ) {
	// t0 = getTime();
	p1 = line.indexOf( " " );
	if ( p1 == -1 || line.charAt( p1 + 2 ) != ' ' ) {
		return false; // invalid line
	}
	id = line.substring( 0, p1 );
	type = line.charAt( p1 + 1 );
	var value = line.substring( p1 + 3 );
	// t1 = getTime();
	// proc2 += t1 - t0;
	value = URLDecode( value );
	// t2 = getTime();
	// proc3 += t2 - t1;
	var element = my_getelementbyid( id );
	// alert("assigning value "+value+"\nto "+id);
	try {
		if ( 'T' == type ) {
			// alert("old innerHTML: "+element.innerHTML)
			element.innerHTML = value;
			// alert("value assigned to "+id);
			// alert("new innerHTML: "+element.innerHTML)
			// alert("value assigned to "+id);
			// executescripts(div);
			// t3 = getTime();
			// proc4 += t3 - t2;
			return true;
		}
		if ( 'S' == type ) {
			element.innerHTML = "";
			// t3 = getTime();
			// proc4 += t3 - t2;
			// t4 = getTime();
			eval( value );
			// proc5 += t4 -t3;
			return true;
		}
		// alert("line "+line+" contains an unknown type.");
	}
	catch ( akarmi ) {
		// alert("element "+id+" invalid? ("+akarmi+": "+akarmi.description+",
		// "+akarmi.message+")");
	}
	// alert("a line could not be processed :"+line);
	// alert("the decoded value was :"+value);
	return false;
}

/*
 * this function processes the lines in allData
 */
function process( allData ) {
	// alert("allData is now: "+allData);
	// t = getTime();
	currentUpdateData = allData.split( "\n" );
	forceUpdate = false;
	if ( !lastUpdateData ) {
		forceUpdate = true;
		lastUpdateData = allData.split( "\n" );
	}
	for ( var i = 0; i < currentUpdateData.length; i++ ) {
		if ( !forceUpdate && currentUpdateData[ i ] == lastUpdateData[ i ] ) {
			continue;
		}
		lastUpdateData[ i ] = currentUpdateData[ i ];
		line = new String( currentUpdateData[ i ] );
		// proc1 += getTime() - t;
		// alert("line is "+line);
		applyLine( line );
		// alert("applyLine("+line+") returned.");
		// allData = allData.substring(p+1);
		// setTimeout("process()", 1);
		// alert("allData is now: "+allData);
		// t = getTime();
		// p = allData.indexOf("\n");
	}
	// proc1 += getTime() - t;
	// applyLine(allData);
	// restart after 10 seconds
	if ( navigator.appVersion.indexOf( "MSIE" ) != -1 ) {
		xmlhttp.abort();
	}
	// top.setTimeout(xmlhttpcallrequest, 10000);
	// alert("procTime...?");
	procTime = getTime() - startTime;
	// alert("max...?");
	schTime = Math.max( 1000, 2000 + reqTime * 4 - procTime );
	// alert("reqTime="+reqTime+", procTime="+procTime+", schTime="+schTime);
	// alert("proc1="+proc1+", proc2="+proc2+", proc3="+proc3+", proc4="+proc4+",
	// proc5="+proc5);
	setTimeout( xmlhttpcallrequest, schTime );
}

var startTime;
var reqTime;
// var proc1; // presenting a line
// var proc2; // parsing a line
// var proc3; // URLDecoding the value
// var proc4; // setting innerHTML
// var proc5; // eval-ing script
/*
 * this function will be called if the update request returns a result
 */
function xmlhttpstatechanged() {
	if ( xmlhttp.readyState == 4 || xmlhttp.readyState == "complete" ) {
		// alert("received.");
		startTime = getTime();
		// proc1=0;
		// proc2=0;
		// proc3=0;
		// proc4=0;
		// proc5=0;
		reqTime = startTime - requestDate.getTime();
		// alert("reqTime="+reqTime);
		allData = new String( xmlhttp.responseText );
		if ( allData.charAt( 0 ) == '<' ) {
			// server side failure/exception
			setTimeout( xmlhttpcallrequest, 10000 + reqTime );
			// alert("Page update failed to complete due to server error.");
			return;
		}
		// alert("allData="+allData);
		process( allData );
	}
}
var requestDate;
/*
 * This method sends the update request
 */
function xmlhttprequest( xmlhttp_, url ) {
	try {
		if ( updateDataQuery ) {
			// url=url+"&random="+Math.random(); //do not cache results
			xmlhttp_.onreadystatechange = xmlhttpstatechanged;
			xmlhttp_.open( "POST", url, true );
			xmlhttp_.setRequestHeader( 'Content-Type', 'application/x-www-form-urlencoded;charset=iso-8859-2' );
			reqPars = "cContext=" + pageContext + "&cUpdateData=true&r_no_refresh=true" + updateDataQuery;
			// xmlhttp_.setRequestHeader("Content-Type",
			// "application/x-www-form-urlencoded");
			xmlhttp_.setRequestHeader( "Content-Length", reqPars.length );
			xmlhttp_.send( reqPars ); // requestparams
			requestDate = new Date();
		}
		else { // maybe the page is not fully loaded
			setTimeout( xmlhttpcallrequest, 1000 );
		}
	}
	catch ( anything ) {
		setTimeout( xmlhttpcallrequest, 1000 );
	}
}

function xmlhttpcallrequest() {
	var answer = true;// confirm("pdteljek?");//true
	if ( answer ) {
		xmlhttprequest( xmlhttp, location.pathname );
	}
}

// =========================================================================

/*
 * this method runs the javascripts in a given node
 */
function executescripts( node ) {
	var x = node.getElementsByTagName( "SCRIPT" );
	alert( "node is " + node + ", Length: " + x.length );
	// + "\nFirst Item: "
	// + x[0].childNodes[0].nodeValue);

	for ( var i = 0; i < x.length; i++ ) {
		alert( "running script: " + x[ i ].text );
		eval( x[ i ].text );
		alert( "script finished." );
	}
	var y = node.children;
	alert( "node is " + node + ", Length: " + y.length );
	for ( var i = 0; i < x.length; i++ ) {
		alert( "running script: " + x[ i ].text );
		// eval(x[i].text);
		alert( "script finished." );
	}

}

// =========================================================================
// =========================================================================

// initialising update process
// wait a bit..otherwise ID tags won't exist
// (the page is not fully loaded yet!)
setTimeout( xmlhttpcallrequest, 2000 );
