<%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%>
<%@page import="imagemed.jsputil.RedirectToolbox"%>
<%@page import="imagemed.dotcom.DotcomConfig"%>
<%@page import="imagemed.jsputil.AttachmentManager"%>
<%@page import="imagemed.util.RunCommandResult"%>
<%@page import="java.util.ArrayList"%>
<%@page import="java.util.List"%>
<%@page import="imagemed.types.string.IMTypeiS"%>
<%@page import="java.sql.ResultSet"%>
<%@page import="imagemed.util.Helper"%>
<%@page import="imagemed.imsession.*"%>
<%@page import="com.erad.pacs.app.broker.table.internals.*,com.erad.pacs.app.broker.table.internals.imtables.*, com.erad.pacs.app.broker.table.internals.action.*,
			com.erad.pacs.app.broker.table.internals.lists.*, com.erad.pacs.app.broker.table.internals.imtables.DBLDSWrapperSqlResultImpl.IncrementalContextImpl"%>
<%@page import="java.sql.Statement"%>
<%
	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = userManager.getSessitaSession( request, response );

	String studyIUID = request.getParameter("cStudyIUID");
	boolean isPDF = "true".equals( request.getParameter("cPDF") );
	boolean isUploadOnly = "true".equals( request.getParameter("cUploadOnly") );
	String doctypeDefault = request.getParameter("cDoctypeDefault");
	// boolean isPACSOrder = "true".equals( is.request.getParameter("cPACSOrder") );
	if (DotcomConfig.selfDevice().isDbOnly()) {
		//redirect
		String idBase = RedirectToolbox.getRedirectForStudy( sess, studyIUID );
		StringBuilder sb = new StringBuilder( idBase );
		sb.append( "/cases/preDicomScan.jsp" + "?cStudyIUID=" + Helper.URLEncodeUTF8( studyIUID ) );
		sb.append( "&cPDF=" + isPDF );
		if( isUploadOnly ) {
			sb.append( "&cUploadOnly=true" );
		}
		sb.append( "&cDoctypeDefault=" + Helper.URLEncodeUTF8( doctypeDefault ) );
		sb.append( "&" + RedirectToolbox.getRedirectParams( sess, request ) );
		response.sendRedirect( sb.toString() );
		return;
	}
	String uploadURL = "/cases/uploadDicom.jsp";
	
	//get series UID
	String seriesUID = "";
	List<String> cmd = new ArrayList<String>();

	cmd.add( IMEnvBase.getEnv( "UTILS_HOME" ) + "/bin/createUID" );
	cmd.add( "series" );
	RunCommandResult runResult = Helper.runCommandEx( cmd.toArray( new String[ 0 ] ) );
	if ( runResult.getExitCode() != 0 ) {
		Helper.ERRORLOG( "DicomUpload", "Generate series UID error: " + runResult.getError() );
	}
	if ( runResult.getOutput() != null ) {
		seriesUID = runResult.getOutput().trim();
	}
	else {
		Helper.ERRORLOG( "DicomUpload", "Generated series UID is NULL!" );
	}

	Helper.DEBUG("DicomUpload", "Generated series UID: " + seriesUID );
	
	String refererHost = request.getParameter("RefererHost");
	String parentSession = request.getParameter("ParentSession");
	String redirPart = "" + ( refererHost == null ? "" : "&RefererHost=" + refererHost ) + ( parentSession == null ? "" : "&ParentSession=" + parentSession );
	
	response.sendRedirect( "/scheduler/scan.jsp?cSaveform=false&" + ( isPDF ? "cPDF=true&" : "" ) +
			( isUploadOnly ? "cUploadOnly=true&" : "" ) +
			"cSeriesUID=" + Helper.URLEncodeUTF8(seriesUID) + 
			"&settings=" + AttachmentManager.getScanSettings() + "&cStudyIUID=" + studyIUID +
			"&cDoctypeDefault=" + Helper.URLEncodeUTF8( doctypeDefault ) +
			redirPart +
			"&cUpload=" + Helper.URLEncodeUTF8( uploadURL + "?" + redirPart ) );
%>
