<%--
 * Component: dotcom
 *
 * Description:
 *     Prints study data for correcting studies existing on multiple legs
 *     Output will be parsed by classes under imagemed.dotcom.multihub on the peer
 *
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@
	page import="java.util.*, imagemed.taskd.TaskToolbox"

%><%@
	page errorPage="../main/exceptionHandler.jsp"

%><%

	response.setContentType( "text/plain" );

	String peerDevice = null;
	
	try {
		Properties prpPeer = imagemed.jsputil.DotcomToolbox.checkClient( request.getRemoteAddr() );
		peerDevice = prpPeer.getProperty( "ID" );
		if ( null == peerDevice || "".equals( peerDevice ) ) {
			throw new Throwable();
		}
	}
	catch ( Throwable th ) {
		out.println( "Unauthorized peer" );
		return;
	}
	
	
	String parJob = request.getParameter( "cJobId" );
	String parPriority = request.getParameter( "cRelPriority" );

	if ( parJob == null ) {
		out.println( "Missing parameter: cJobId" );
		return;
	}
	
	if ( parPriority == null ) {
		out.println( "Missing parameter: cRelPriority" );
		return;
	}

	TaskToolbox.changeRelPriority( parPriority, parJob );
	TaskToolbox.propagateRelPriorityChange( parPriority, parJob, peerDevice );
	
	out.println( "OK" );
%>