<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--<%@page import="imagemed.util.Syslog"%>
<%@page import="imagemed.util.OperLogEntry"%>
<%@page import="imagemed.jsputil.PluginToolbox"%>
<%@page import="imagemed.types.string.IMTypefw"%>
<%@page import="java.util.TreeSet"%>
<%@page import="imagemed.jsputil.IMAdminLogger"%>
<%@page import="imagemed.util.JSHelper"%>
<%@page import="imagemed.http.tabs.TabBean"%>
<%@page import="imagemed.util.IMProperties"%>
<%@page import="imagemed.jsputil.IMAdminToolbox"%>
<%@page import="java.util.List"%>
<%@page import="java.util.ArrayList"%>
<%@page import="imagemed.util.LocalizedMessage"%>
<%@page import="imagemed.types.flag.IMTypeur"%>
<%@page import="java.io.IOException"%>
<%@page import="java.sql.Statement"%>
<%@page import="java.sql.SQLException"%>
<%@page import="java.sql.ResultSet"%>
<%@page import="imagemed.imsession.IMEnv"%>
<%@page import="java.util.Properties"%>
<%@page import="imagemed.util.Helper"%>
<%@page import="java.io.File"%><%---------------------------	Can change enabled plugins   --------------------------- %>
<%@
  page errorPage ="../main/exceptionHandler.jsp"
%><%@page import="imagemed.taskd.*, imagemed.lists.ListDescriptor, imagemed.imsession.IMSession"%>
<%

  IMSession is = new IMSession(request, response, out); 
  if (!is.regOK()) {
    return;
  }

  if( !is.hasRight( IMTypeur.ADMIN_RIGHT ) ) {
%>
<HTML><BODY>Admin right is needed for this page</BODY></HTML>
<%  	
  	return;
  }
  
  String parOp = request.getParameter( "op" );
%><%!
	//write options for a table  
	void writeOptions( String table, String IDfield, JspWriter out ) throws IOException {
		try {
			String query = "select " + IDfield + " from " + table + " order by " + IDfield;
			Statement st = IMEnv.getDB().createStatement();
			ResultSet rs = st.executeQuery( query );
			List<String> names = new ArrayList<String>();
			while( rs.next() ) {
				String ID = rs.getString( IDfield );
				if( ID != null ) {
					out.println( "<OPTION value=\"" + ID + "\">" + ID );
				}
			}
			st.close();
		}
		catch( SQLException e ) {
			out.println( Helper.throwable2String( e ) );
		}
	}

	void backButton( IMSession is, JspWriter out ) throws IOException {
		out.println( "<A href=\"plugins.jsp\" onMouseOver=\"window.status='Back'; return true;\" >" +
			JSHelper.getJsButton( is, "backButton", 24, 24, "") + "</A>" );
	}
%>
<HTML><HEAD><TITLE>Change Enabled Plugins</TITLE>
<%
	JSHelper.printJsInclude( out, JSHelper.IMPOPUP_JS );
%>
</HEAD><BODY>
<font face="arial, helvetica, universe, sans-serif">
<%
	if( "save".equals( parOp ) ) {
		imagemed.tables.Table.printCommonScript(is);
		//ha a normal reszben kiirom, elkurja az Add/Remove alignmentet (biztos css miatt)
		
		String[] parPlugins = request.getParameterValues( "plugins" );
		String[] parUsers = request.getParameterValues( "users" );
		String mode = request.getParameter( "mode" );
		boolean isRemove = "remove".equals( mode );
	  
		if( parPlugins == null || parPlugins.length == 0 ) {
			out.println( "No plugin specified<BR>" );
			backButton( is, out );
			return;
		}
		if( parUsers == null || parUsers.length == 0 ) {
			out.println( "No user specified<BR>" );
			backButton( is, out );
			return;
		}

		out.println( "Plugins: " );
		for( int i = 0; i < parPlugins.length; i++ ) {
			out.print( parPlugins[ i ] );

			if( i < parPlugins.length - 1 ) {
				out.print( ", " );
			}
 		}	
  	
		out.println( "<BR>Mode: " + mode + "<BR>" );
  		out.println( "Users: " );
  		for( int i = 0; i < parUsers.length; i++ ) {
  			out.println( parUsers[ i ] );
  			if( i < parUsers.length - 1 ) {
  				out.println( ", " );
  			}
  		}
  		out.print( "<BR>" );

		Statement st = IMEnv.getDB().createStatement();

		Properties plugins = new Properties();
		for( int j = 0; j < parPlugins.length; j++ ) {
			String plugin = parPlugins[ j ];
			if( isRemove ) {
				plugins.setProperty( plugin, "false" );
			}
			else {
				plugins.setProperty( plugin, "true" );
			}
		}
		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.ADMIN, "userMODIFY" );

		logEntry.setField( OperLogEntry.FIELD.USER, is.regID );
		logEntry.setField( OperLogEntry.FIELD.USER_GROUP_OR_USER, "USER" );
		logEntry.setField( OperLogEntry.FIELD.USER_MODIFIED, "PLUGIN" );

	  	for( int i = 0; i < parUsers.length; i++ ) {
	  		String user = parUsers[ i ];
	  		logEntry.setField( OperLogEntry.FIELD.USER_MODIFIED_USER, user );
	  		List<String> oldPlugins = PluginToolbox.getPluginsFor( user );
	  		
  			//preparing for logging changes
//  			IMAdminLogger logger = new IMAdminLogger( is.regID, parUsers[ i ] );
 // 			logger.setOldState();
  			//logging init done
  			PluginToolbox.setPluginsFor( parUsers[ i ], plugins );
	  		
  			// log only what's really changed
			boolean change = false;
			String mess = "";

			if( isRemove ) {
				for( int j = 0; j < oldPlugins.size(); j++ ) {
					if( "false".equals( plugins.getProperty( oldPlugins.get( j ) ) ) ) {
						// actually removed
						mess += "The plugin " + oldPlugins.get( j ) + " was set to false. ";
						change = true;
					}
				}
			}
			else {
		  		List<String> newPlugins = PluginToolbox.getPluginsFor( user );
				for( int j = 0; j < newPlugins.size(); j++ ) {
					if( !oldPlugins.contains( newPlugins.get( j ) ) ) {
						// actually added
						mess += "The plugin " + newPlugins.get( j ) + " was set to true. ";
						change = true;
					}
				}
			}
			
			if ( change ) {
				logEntry.setField( OperLogEntry.FIELD.USER_CHANGEINFO, mess );
				logEntry.log( "PluginToolbox", 0, Syslog.LOG_INFO );
			}
  			
 // 			logger.setNewState();
//			logger.writeLog();
	  	}

		out.println( "<BR>Changes completed<BR>" );
		backButton( is, out );
	}
	else {
%>
		<B><CENTER><FONT size=6>Change Enabled Plugins for Users</FONT></CENTER></B>
		<form action="plugins.jsp" method="post">
		<input type="hidden" name="op" value="save">
		<br><table border=2><tr><td>
		Users
		</td><td> 
		Groups
		</td><td> 
		Plugins
		</td><td> 
		Mode
		</td><td> 
		&nbsp;
		</td></tr>
		<tr valign="top"><td>		
		<select id="users" name="users" multiple size="16">
		<%
			writeOptions( "Access", "USERID", out );
		%>  
		</select>
		</td><td> 
		
		<select id="groups" name="groups" multiple size="16">
		<%
			writeOptions( "Groups", "ID", out );
		%>  
		</select>
		
		<script language='JavaScript'>
			document.getElementById("groups").onchange = function(){
				var gr = document.getElementById("groups");
				var us = document.getElementById("users");
				var values = "";
				for (var i = 0; i < gr.options.length; i++) {
					if (gr.options[ i ].selected) {
						values += "cGroup=" + gr.options[ i ].value + "&";
					}
				}
//				alert( values );
				if( values == "" ) {
					//unselect all
					for( var i = 0; i < us.options.length; i++ ) {
						us.options[ i ].selected = false;
					}						
				}
				else {
				 	var ret = IMgetContent( "/imadmin/getUsersbygroups.jsp?" + values );
				 	if( ret.code == 0 ) {
//				 		alert( ret.text );
						var users = ret.text.split( "," );
						var ai = 0;
						for ( var i = 0; i < users.length; i++ ) {
							var userSel = users[ i ];
							while( ai < us.options.length ) {
								if( us.options[ ai ].value == userSel ) {
									us.options[ ai ].selected = true;
									ai = ai + 1;
									break;
								}
								else {
									us.options[ ai ].selected = false;
									ai = ai + 1;
								}
							} 
						}
						while( ai < us.options.length ) {
							us.options[ ai ].selected = false;
							ai = ai + 1;
						}
				 	}
				}
			};
		</script>	
		
		</td><td> 
		
		<select name="plugins" multiple size="16">
		<%
			String[] allPlugins = PluginToolbox.getAllPlugins();
			if ( allPlugins != null && allPlugins.length > 0 ) {
/* itt direkt az oszeset engedjuk macerazni				
				List<String> plugins = new ArrayList<String>();
				for ( int i = 0; i < allPlugins.length; i++ ) {
					if ( PluginToolbox.isPluginHandledSeparately( allPlugins[ i ] ) ) {
						plugins.add( allPlugins[ i ] );
					}
				}
				for( int i = 0; i < plugins.size(); i++ ) {
*/					
				for ( int i = 0; i < allPlugins.length; i++ ) {
					String enc = Helper.htmlEncode( allPlugins[ i ] );
					out.println( "<OPTION VALUE=\"" + enc + "\">" );
					out.println( enc );
					out.println( "</OPTION>" );
				}
			}
		%>
		</select>
		</td><td> 
		
		<select name="mode" size="16">
			<option value="add" selected>Enable
			<option value="remove">Disable
		</select>
		</td><td> 
		<input type="submit" value="Change">
		</td></tr>
		</table>
		</form>
<%		
	}
%>
</BODY></HTML>--%>