
function hideSaveNotification() {
	var snSpan = getelementbyid( "save_notification" );
	snSpan.style.visibility = "hidden";
}


function showMediaWarning( label ) {
	var warningSpan = getelementbyid( "up_media_warning" );
	var compressSpan = getelementbyid( "up_media_warning_compression" );
	warningSpan.style.visibility = "visible";
	compressSpan.innerHTML = label + ' ';
}

function hideMediaWarning() {
	var warningSpan = getelementbyid( "up_media_warning" );
	warningSpan.style.visibility = "hidden";
}

function resetMediaProfiles( type, compression ) {
	var types = getelementbyid( "up_media_type" );
	var compressions = getelementbyid( "up_media_compression" ) ;

	for ( i = 0; i < types.length; i++ ) {
		if ( types.options[ i ].value == type ) {
			types.options[ i ].selected = true;
			break;
		}
	}

	for ( i = 0; i < compressions.length; i++ ) {
		if ( compressions.options[ i ].value == compression ) {
			compressions.options[ i ].selected = true;
			break;
		}
	}

	onMediaTypeSelected( false );
}

function onMediaCompressionSelected() {
	var compressions = getelementbyid( "up_media_compression" ) ;
	var options = compressions.options;
	var optId = options[ compressions.selectedIndex ].id;
	if ( optId == "up_mc_asis" ) {
		showMediaWarning( options[ compressions.selectedIndex ].text );
		return;
	}

	var types = getelementbyid( "up_media_type" )
	var selectedType = types.options[ types.options.selectedIndex ].id;
	if ( selectedType == "up_mt_cd" || selectedType == "up_mt_ram" ) {
		if ( optId == "up_mc_jpeg" || optId == "up_mc_jp2k" ) {
			showMediaWarning( options[ compressions.selectedIndex ].text );
			return;
		}
	}

	hideMediaWarning();
}

function onMediaTypeSelected( doChange ) {
	var types = getelementbyid( "up_media_type" )
	var optId = types.options[ types.options.selectedIndex ].id;

	var jpegOpt = getelementbyid( "up_mc_jpeg" );
	var jp2kOpt = getelementbyid( "up_mc_jp2k" );
	var uncompOpt = getelementbyid( "up_mc_uncomp" );
	var asisOpt = getelementbyid( "up_mc_asis" );

	if ( optId == "up_mt_cd" || optId == "up_mt_ram" ) {
		jpegOpt.style.color = "GoldenRod";
		jp2kOpt.style.color = "GoldenRod";
		if ( doChange ) {
			uncompOpt.selected = true;
		}
	}
	else {
		jpegOpt.style.color = uncompOpt.style.color;
		jp2kOpt.style.color = uncompOpt.style.color;
		if ( asisOpt.selected && doChange ) {
			uncompOpt.selected = true;
		}
	}
	onMediaCompressionSelected()
	return;
}
