<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 * Component: prior
 *
 * Description:
 *  Lists prior studies for a study (patient).
 *
 * Parameters:
 *
 *   cStudy          Study Instance UID
 *   cRelevName      Patient Name of the study
 *   cAutoRetrieve   Start autoretriveing prior studies from archive/QR devices
 *   cLocalOnly      Check only the local server for prior studies
 *   cBack           Back URL
 *   cDebug          Also flag local studies if they are autoretrive priors or not
 *
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
-- %><%@page import="com.erad.pacs.common.interfaces.result.RelevantResult"%>
<%@page import="com.erad.pacs.common.interfaces.table.TableParams"%>
<%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%@
	page import="java.util.*, java.sql.*, imagemed.imsession.*, imagemed.exception.*, imagemed.types.*,
			imagemed.http.*, imagemed.dcprocessing.*, com.erad.pacs.app.broker.table.internals.*,com.erad.pacs.app.broker.table.internals.imtables.*, com.erad.pacs.app.broker.table.internals.action.*,
			com.erad.pacs.app.broker.table.internals.lists.*, com.erad.pacs.app.broker.table.internals.imtables.DBLDSWrapperSqlResultImpl.IncrementalContextImpl,
			imagemed.util.*, imagemed.types.string.*, imagemed.jsputil.*, java.text.Format"

%><%-- class variables -- %><%!

	boolean hasParent() throws SQLException {
		String query = "select AE from "+IMEnvBase.getEnv("TARGETTBL")+" where TYPE='P'";
		ResultSet rs = IMEnv.getDB().createStatement().executeQuery(query);
		return rs.first();
	}

	void redirectToGetpbs(IMSession is) {
		// getpbs is always http. There is not much information in there
		// getpbs is http if the browser is MSIE
		// it will still reference https:// for the object and study .pac files

		String study       = is.imRequest.getVal("cStudy");
		String tableParams = is.imRequest.getVal("cTableParams");

		String queryString = "?cGr=" + study;
		if (tableParams != null)
			queryString = queryString + "&cPrevNext=true" + tableParams;

		String loc = is.httpx_host + GetpbsToolbox.getURLforGetpbs() + queryString;
		try{
			is.response.sendRedirect(loc);
		}
		catch (Throwable t) {
		}
	}

%><%

	IMSession is = new IMSession(request, response, out);
	if (!is.regOK()) {
		return;
	}
	IMRequest parReq = is.imRequest;
	boolean shouldRedir = (is.imRequest.m_context == null || is.request.getParameterMap().containsKey("cDisposableContext"));
	String contextName = is.imRequest.passAsFile(is.imRequest.m_context);
	if (shouldRedir) {
		response.sendRedirect("/prior/index.jsp?cContext="+contextName);
		return;
	}
	String parBack = parReq.getVal("cBack");
	if (parBack == null) {
		parBack = "/cases/index.jsp";
	}
	parBack += "&cDisposableContext="+contextName;

	boolean isDebug       = "true".equals(parReq.getVal("cDebug"));
	String parStudy       = parReq.getVal("cStudy");
	String parRelevName   = parReq.getVal("cRelevName");
	if (parRelevName == null) {
		String qStudy = "select PNAME from " + IMEnvBase.getEnv("STUDYTBL") +
				" where STYIUID='" + parStudy + "'";
		PreparedStatement psStudy = IMEnv.getDB().prepareStatement(qStudy);
		try ( ResultSet rsStudy = psStudy.executeQuery() ) {
			if (rsStudy.next()) {
				parRelevName = IMTypePN.displayOrdinaryText(rsStudy.getString("PNAME"));
			}
		}
	}


	boolean bLocalOnly    = "true".equals(parReq.getVal("cLocalOnly"));
	int resultMode = RelevantResultImpl.MODE_NORMAL;
	if (bLocalOnly) {
		resultMode = RelevantResultImpl.MODE_LOCALONLY;
	}
	boolean openSingle    = "true".equals(parReq.getVal("cOpenSingle"));

// Some setup

	PriorToolbox.m_retrieveConfigReader.checkAndLoad();
	PriorRetrieveConfig retrieveConfig = (PriorRetrieveConfig) PriorToolbox.m_retrieveConfigReader.getConfiguration();

	boolean hasEditRight    = (is.regRights != null && is.regRights.indexOf("E") != -1);
	TableParams tparams = PriorToolbox.createTableParams(is);

	String thisPageFN   = "/prior/index.jsp";          // Full Name
	
	String globalNoPass    = "r_no_refresh,r_setc";

%><%--  Prepare tables -- %><%

	PriorRetrieveManager retrieveManager = new PriorRetrieveManager( retrieveConfig, parStudy, isDebug );

	RelevantResult result = PriorToolbox.getPriorResult( is, parStudy, tparams, resultMode, new String[] { "NIMG", "SSUI" }, false );

	String error = retrieveManager.process(result, is);
	if (error != null) {
		if (error.equals(PriorRetrieveManager.STUDYMISSING)) {
			throw new IMGeneralException(LocalizedMessage.getSimpleMessage( "EXCEPTION_PRIOR_INDEX_ORIGINAL_STUDY_DELETED_MERGED_SPLIT" ), "cases/index.jsp", LocalizedMessage.getSimpleMessage( "EXCEPTION_PRIOR_INDEX_PROCESS_EXCEPTION" ), parBack);
		}
		throw new IMGeneralException(LocalizedMessage.getSimpleMessage( "EXCEPTION_PRIOR_INDEX_COLLECTING_PRIOR_STUDIES" ) + " ("+error+")", "cases/index.jsp", LocalizedMessage.getSimpleMessage( "EXCEPTION_PRIOR_INDEX_PROCESS_EXCEPTION" ), parBack);
	}

	// Check if we should redirect to getpbs
	if (openSingle) {
		if (bLocalOnly) {
			if (result.getLocalOpenableCount() == 1) {
				redirectToGetpbs(is);
				return;
			}
		}
		else {
			if (result.countAll() == 1) {
				redirectToGetpbs(is);
				return;
			}
		}
	}


	String qs = is.request.getQueryString();
	qs = (qs == null) ? "" : "?" + qs;
	String tU = is.httpx_host + is.request.getRequestURI() + qs;
	String encodedThisURL = Helper.URLEncodeUTF8( tU );
	String backParams  = "&cBack=" + encodedThisURL;
	String getpbsLink  = is.httpx_host + GetpbsToolbox.getURLforGetpbs() + "?cGr=$$SYUI$$";

	TableDescriptorImpl tdesc = new TableDescriptorImpl(thisPageFN);

	Properties extraProperties = new Properties();
	extraProperties.setProperty("Rights",(is.regRights == null ? "" : is.regRights));
	extraProperties.setProperty("Relev", "true");
	extraProperties.setProperty("BackParams", backParams);

	WorklistPropertiesImpl tprop = new WorklistPropertiesImpl(extraProperties);

	tdesc.setTableParams(tparams);
	tdesc.setTableProperties(tprop);
	tdesc.setFieldManager(retrieveConfig.getFieldManager());

	boolean needDotDot = bLocalOnly && RelevantResultImpl.hasArchive();

	int nActs = 5;
	if (needDotDot)
		nActs++;

	ActionImpl[] acts = new ActionImpl[nActs];
	nActs = 0;
	acts[nActs++] = new OpenAction(tdesc, "SYUI", getpbsLink,
			"<script language=\"JavaScript\">getImage(\"open\", 21, 20, \" alt=\\\"Open $$PANM$$\\\"\");</script>",
			"<script language=\"JavaScript\">getImage(\"spacer\", 21, 20, \"\");</script>",
			"Open $$PANM$$");

	acts[nActs++] = new LinkAction(tdesc, "SYUI", "/archive/get.jsp?cDevStudy=$$RSRC$$+$$SYUI$$" ,
			"<script language=\"JavaScript\">getImage(\"get\", 16, 20, \" alt=\\\"Retrieve $$PANM$$\\\"\");</script>",
			"Retrieve $$PANM$$");
	acts[nActs++] = new LinkAction(tdesc, "SYUI", "/cases/index.jsp?cQV=$$SYUI$$"+parReq.getVal("cTableParams")+"&cDisposableContext="+contextName,
			"<script language=\"JavaScript\">getImage(\"qview\", 18, 20, \" alt=\\\"Quick view $$PANM$$\\\"\");</script>",
			"Quick view $$PANM$$");
	acts[nActs++] = new LinkAction(tdesc, "SYUI",
			"JavaScript: redirPage_edit(\"$$SYUI$$\", lockid)",
			"<script language=\"JavaScript\">getImage(\"edit\", 18, 20, \" alt=\\\"Edit $$PANM$$\\\"\");</script>",
			"Edit $$PANM$$");
	acts[nActs++] = new LinkAction(tdesc, "SYUI",
			"JavaScript: redirPage_casesForward(\"$$SYUI$$\")",
			"<script language=\"JavaScript\">getImage(\"forward\", 18, 20, \" alt=\\\"Forward $$PANM$$\\\"\");</script>",
			"Forward $$PANM$$");

	if (needDotDot) {
		acts[nActs++] = new LinkAction(tdesc, "SYUI",
				"/prior/index.jsp?cStudy=$$SYUI$$&cRelevName=$$PANM$$" +
				backParams + tparams.getPassFields(),
				"<script language=\"JavaScript\">getImage(\"prior\", 17, 20, \" alt=\\\"Archived studies for $$PANM$$\\\"\");</script>",
				"Archived studies for $$PANM$$");
	}

	String placeHolder[] = new String[4];
	placeHolder[0] = "<script language=\"JavaScript\">getImage(\"spacer\", 16, 20, \"\");</script>";

	if (needDotDot) {
		placeHolder[1] = "<script language=\"JavaScript\">getImage(\"spacer\", 1, 20, \"\");</script>";
	}
	else {
		placeHolder[1] = placeHolder[0];
	}
	placeHolder[2] = "<script language=\"JavaScript\">getImage(\"spacer\", 18, 20, \"\");</script>";
	placeHolder[3] = "<script language=\"JavaScript\">getImage(\"spacer\", 18, 20, \"\");</script>";

	ColumnImpl col = null;
	ActionImpl act[] = new ActionImpl[bLocalOnly ? 2 : 3];
	int nAct = 0;
	act[nAct++] = new RelevantCheckbox(tprop, "SYUI", "cGr", retrieveManager, true, isDebug);
	if (!bLocalOnly)
		act[nAct++] = new RelevantCheckbox(tprop, "SYUI", "cDevStudy", retrieveManager, false, isDebug);
	act[nAct++] = new RelevantAction(tprop, acts, placeHolder);

	int batchNum = bLocalOnly ? 2 : 4;
	if (hasEditRight) {
		batchNum++;
	}

	ActionImpl batchAct[] = new ActionImpl[batchNum];
	batchAct[0] = new LinkAction(tdesc, null, "JavaScript:BatchOpen_(" + IMSession.isGetPbsServlet() + ")",
			"<script language=\"JavaScript\">getImage(\"open\", 21, 20, \" alt=\\\"Open selected studies\\\"\");</script>", "Open selected studies");
	if (hasEditRight) {
		batchAct[1] =  new LinkAction(tdesc, null, "JavaScript:BatchMerge_()",
				"<script language=\"JavaScript\">getImage(\"merge\", 19, 17, \" alt=\\\"Merge selected studies\\\"\");</script>", "Merge selected studies");
	}
	if (!bLocalOnly) {
		batchAct[batchNum-3] = new SeparatorAction(tprop, "SYUI");
		batchAct[batchNum-2] = new LinkAction(tdesc, null, "JavaScript:BatchGet_()",
				"<script language=\"JavaScript\">getImage(\"get\", 16, 20, \" alt=\\\"Retrieve selected studies\\\"\");</script>", "Retrieve selected studies");
	}
	
	batchAct[batchNum-1] = new LinkAction(tdesc, null, "JavaScript:BatchFwd_()",
				"<script language=\"JavaScript\">getImage(\"forward\", 16, 20, \" alt=\\\"Forward selected studies\\\"\");</script>",
			  	"Forward selected studies");

	col = new ColumnImpl(new RelevantBatch(batchAct), new ActionCell("SYUI", act), "SYUI");
	tdesc.addExtraColumn("_FIRST",col);

	if (parStudy != null)
		tdesc.setHighRow("SYUI", parStudy);

	String backToList = "&nbsp;&nbsp;<A href=\"" + parBack + "\">"+
			JSHelper.getJsLocalizedButton( "BUTTON_BACK_TO_LIST", "BUTTON_NULL", false ) + "</a>";

	String tableParamsPart = is.imRequest.getVal("cTableParams");
	String wlContext = null;
	int p = tableParamsPart==null?-1:tableParamsPart.indexOf("&cContext=");
	if (p > -1) {
		wlContext = tableParamsPart.substring(p+10);
		p = wlContext.indexOf("&");
		if (p > 0) {
			wlContext = wlContext.substring(0, p);
		}
		tableParamsPart = "&cTableParams="+Helper.URLEncodeUTF8(tableParamsPart);
	}
	boolean isPrevNext = wlContext != null && wlContext.length() > 0;
	String fieldPart = "";
	String[] fields = is.imRequest.getVals("cFields");
	if (fields != null && fields.length > 0) {
		fieldPart = "&cFields="+fields[0];
		for (int i=1; i<fields.length; i++) {
			fieldPart += "%0A"+fields[i];
		}
	}
	
	String prevNextURL = "index.jsp?cLocalOnly="+bLocalOnly+fieldPart+tableParamsPart+"&cBack="+Helper.URLEncodeUTF8(parBack)+"&cStudy=";
	TopCellImpl topCell[] = new TopCellImpl[isPrevNext?4:3];
	Properties titleProps = new Properties();
	titleProps.setProperty("width", "30%");
	titleProps.setProperty("align", "left");
	int i=0;
	topCell[i++] = new SimpleTopCell(tprop, LocalizedMessage.getCompoundMessage( "PRIOR_INDEX_RELEVANT_CASES_FOR", new Format[] { null }, new Object[] { parRelevName }, true ), titleProps);
	if (isPrevNext) {
		topCell[i++] = new PrevNextTopCell(tprop, is, prevNextURL, parStudy, wlContext);
	}
	topCell[i++] = new SimpleTopCell(tprop, backToList);
	topCell[i++] = new PageTopCell(tprop, tparams);
	tdesc.setTopCells(topCell);

	tdesc.setResult(result);
	TableImpl table = new TableImpl(tdesc);

%><%-- ----- HTML code ----- -- %>
<HTML>
<HEAD><TITLE><%= is.http_server %> - <%= LocalizedMessage.getSimpleMessage( "PRIOR_INDEX_RELEVANT_CASES" ) %></TITLE>
 <SCRIPT Language="JavaScript">
 	var pageContext="<%=contextName%>";
 </script>
<%

	table.printScript(tparams, is, new String[] {"cGr", "cStudy"});
	TabToolbox.writeIMpopup(out);

%>
 <SCRIPT Language="JavaScript">

    function doSubmit(frm,val) {
      frm.cStat.value = val;
      frm.submit();
    }


    function BatchOpen_( isGetPbsServlet ) {
      var i;
      var studies = '';

      for (i=0; i<self.document.Batch.length; i++) {
        if (self.document.Batch.elements[i].name == 'cGr') {
          if (self.document.Batch.elements[i].checked) {
            study = self.document.Batch.elements[i].value;
      			key = getelementbyid("cKey_"+study).value;
        		if (key) {
        			studies = studies + '&cKey_'+escape(study)+"="+escape(key); 
        		}
            studies += '&cGr=' + study;
          }
        }
      }
      var url = '/cases/oper.jsp';
      if( isGetPbsServlet ) {
      	url = '/GetPbs/' + ( new Date() ).getTime() + '.pbs';
      }
      document.location.href = url + '?cInstr=Open' + studies + '&<%=tparams.passParamsExcept(globalNoPass+",cBack")%>' + backParam;
    }

    function BatchGet_( ) {
      var i;
      var studies = '';

      for (i = 0; i < self.document.Batch.length; i++) {
        if (self.document.Batch.elements[i].name == 'cDevStudy') {
          if (self.document.Batch.elements[i].checked) {
            studies += '&cDevStudy=' + self.document.Batch.elements[i].value;
          }
        }
      }
      document.location.href = '/archive/get.jsp?a=b' + studies+backParam;
    }

	function BatchMerge_() {
		self.document.Batch.action = "/cases/merge.jsp";
		self.document.Batch.submit();
	}

	function BatchFwd_() {
		var i;
		var studies = '';

		for (i=0; i<self.document.Batch.length; i++) {
			if (self.document.Batch.elements[i].name == 'cGr') {
				if (self.document.Batch.elements[i].checked) {
					studies += 'cGr=' + self.document.Batch.elements[i].value + '&';
				}
			}
		}
		document.location.href = '/cases/forward.jsp?' + studies + '<%=tparams.passParamsExcept(globalNoPass+",cBack")%>' + backParam;
	}
  </script>

</HEAD>
<BODY>
<%

	TabToolbox.makeTabs(is, is.tabbean, "cases/index.jsp", "White");
	
	try {
		table.printTableTop(is);
	}
	catch (Throwable th) {
		Helper.DEBUG("prior/index.jsp", Helper.throwable2String(th));
	}
	
	table.print(is);
	if (bLocalOnly) {
		StringBuffer localOnlyPart = new StringBuffer("");
		localOnlyPart.append("<form>\n");
		localOnlyPart.append("<input type=hidden name=\"cContext\" value=\""+is.imRequest.m_context+"\">\n");
		localOnlyPart.append("<input type=hidden name=\"cLocalOnly\" value=\"false\">\n");
		localOnlyPart.append("<center>"+JSHelper.getJsInputLocalizedButton(is, "BUTTON_MORE", null, null)+"</center>\n");
		
		localOnlyPart.append("</form>\n");
		table.printExtraPart(is, localOnlyPart.toString());
	}
	if (isDebug) {
		is.out.println("<pre>" + retrieveManager.getDebug() + "</pre>");
	}
%>
<%--
<pre>
<%= result.getDebug() %>
</pre>
-- %>
</BODY></HTML>
--%>