#!/bin/sh

HOME=$DOCUMENT_ROOT/..
. $HOME/etc/setenv.sh


VAR_CFG="${DCMTK_VAR}/printer.cfg"
PRINTER_CFG="${CASES_HOME}/printer.cfg"

[ -f ${VAR_CFG} ] && PRINTER_CFG="${VAR_CFG}"

if [ -f ${PRINTER_CFG} ] ; then
  echo "Content-type: text/html"
  echo "Content-length: `wc -c ${PRINTER_CFG} | sed 's/^ *\([^ ]*\) .*$/\1/'`"
  echo "Status: 200"
  echo
  cat ${PRINTER_CFG}
  
else
  echo "Content-type: text/html"
  echo "Status: 403"
  echo

  echo "File not found: printer.cfg"
fi
