<%--
 * Component: cases
 *
 * Description:
 *    Saves the viewer profile for a user.
 *
 * Parameters:
 * 
 *     USERNAME : ID of the user for the profile to be saved
 *     PROFILE  : profile data to be saved
 *
--%><%@page import="imagemed.dotcom.proliferate.ProliferateMode"%>
<%@
	page import="java.io.*,java.util.*,
			com.erad.pacs.connector.Connector,
			com.erad.pacs.services.usermanager.client.Session,
			com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade,
			imagemed.util.Helper, imagemed.imsession.*, imagemed.jsputil.*, imagemed.users.*"

%><% 

	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = userManager.getSessitaSession( request, response );
	
	String strResponse = "ERROR: User not found";
	String strUserName = request.getParameter( "USERNAME" );
	String strProfileData = request.getParameter( "PROFILE" );
	String strRegCookie = sess.getSessionId(  );

	if ( strUserName == null ) {
		strUserName = sess.getUser().getUserId();
	}

	if ( strUserName != null && strRegCookie != null ) {
		UserDir userDir = new UserDir( strUserName );

		String profileName = "profile.xml";
		UserFile profileFile = userDir.getUserFile( profileName );
		UserFile tempFile = userDir.getUserFile( "tmp." + profileName + "." + System.currentTimeMillis() + "." + Helper.getCounter() );

		try {
			if ( !tempFile.prepareForWrite() ) {
				throw new Throwable( "User directory does not exist" );
			}

			if ( strProfileData == null ) {
				throw new Throwable();
			}

			FileOutputStream fOutStream = new FileOutputStream( tempFile.toFile() );
			fOutStream.write( strProfileData.getBytes() );
			fOutStream.close();
			
			if ( !( Helper.renameToNotThrowsException( tempFile.toFile(), profileFile.toFile() ) ) ) {
				throw new Throwable();
			}

			profileFile.proliferate( sess, ProliferateMode.NORMAL );
			
			strResponse = "OK";
		}
		catch ( Throwable th ) {
			strResponse = "ERROR: Profile could not be saved";
		}
		finally {
			if ( tempFile.exists() ) {
				tempFile.toFile().delete();
			}
		}
	}


	response.setContentType( "text/plain" );
	response.setHeader( "Pragma","no-cache" );
		
	out.println( "# SessionID: " + strRegCookie );
	out.println( "# Profile: " + strResponse );

	if ( true ) {
		// For avoiding extra newline(s)
		return;
	}
%>
